# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from bosch_locator_bridge/ClientLocalizationPose.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class ClientLocalizationPose(genpy.Message):
  _md5sum = "ac6078300928d5422e0a422d1c3aef70"
  _type = "bosch_locator_bridge/ClientLocalizationPose"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Copyright (c) 2021 - for information on the respective copyright owner
# see the NOTICE file and/or the repository https://github.com/boschglobal/locator_ros_bridge.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# The time passed between receiving the most recent laser scan and the generation of this Datagram
duration age

# The time at which the Localization Client received the laser scan used to generate this Datagram
time timestamp

# currently unused; this field is reserved to match a uniqueId provided via the ClientSensorLaser interface
uint64 unique_id

# The localization status
int32 state

# Only Datagrams with the same epoch can be treated as locally precise
# and coherent. If the self-localization was temporarily disrupted, the system will
# indicate this by incrementing the epoch
uint64 epoch

# Constants
int32 LOC_STATUS_INFO_LOCALIZATION_NOT_RUNNING = -3
int32 LOC_STATUS_NOT_LOCALIZED_STARTUP = -2
int32 LOC_STATUS_NOT_LOCALIZED = -1
int32 LOC_STATUS_LOCALIZED_ODO_ONLY = 1
int32 LOC_STATUS_LOCALIZED = 2
int32 LOC_STATUS_LOCALIZED_INTERNALUSE1 = 3
int32 LOC_STATUS_LOCALIZED_INTERNALUSE2 = 4
"""
  # Pseudo-constants
  LOC_STATUS_INFO_LOCALIZATION_NOT_RUNNING = -3
  LOC_STATUS_NOT_LOCALIZED_STARTUP = -2
  LOC_STATUS_NOT_LOCALIZED = -1
  LOC_STATUS_LOCALIZED_ODO_ONLY = 1
  LOC_STATUS_LOCALIZED = 2
  LOC_STATUS_LOCALIZED_INTERNALUSE1 = 3
  LOC_STATUS_LOCALIZED_INTERNALUSE2 = 4

  __slots__ = ['age','timestamp','unique_id','state','epoch']
  _slot_types = ['duration','time','uint64','int32','uint64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       age,timestamp,unique_id,state,epoch

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ClientLocalizationPose, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.age is None:
        self.age = genpy.Duration()
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.unique_id is None:
        self.unique_id = 0
      if self.state is None:
        self.state = 0
      if self.epoch is None:
        self.epoch = 0
    else:
      self.age = genpy.Duration()
      self.timestamp = genpy.Time()
      self.unique_id = 0
      self.state = 0
      self.epoch = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2i2IQiQ().pack(_x.age.secs, _x.age.nsecs, _x.timestamp.secs, _x.timestamp.nsecs, _x.unique_id, _x.state, _x.epoch))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.age is None:
        self.age = genpy.Duration()
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 36
      (_x.age.secs, _x.age.nsecs, _x.timestamp.secs, _x.timestamp.nsecs, _x.unique_id, _x.state, _x.epoch,) = _get_struct_2i2IQiQ().unpack(str[start:end])
      self.age.canon()
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2i2IQiQ().pack(_x.age.secs, _x.age.nsecs, _x.timestamp.secs, _x.timestamp.nsecs, _x.unique_id, _x.state, _x.epoch))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.age is None:
        self.age = genpy.Duration()
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 36
      (_x.age.secs, _x.age.nsecs, _x.timestamp.secs, _x.timestamp.nsecs, _x.unique_id, _x.state, _x.epoch,) = _get_struct_2i2IQiQ().unpack(str[start:end])
      self.age.canon()
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2i2IQiQ = None
def _get_struct_2i2IQiQ():
    global _struct_2i2IQiQ
    if _struct_2i2IQiQ is None:
        _struct_2i2IQiQ = struct.Struct("<2i2IQiQ")
    return _struct_2i2IQiQ
