# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from bosch_locator_bridge/ClientLocalizationVisualization.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class ClientLocalizationVisualization(genpy.Message):
  _md5sum = "5734d1fb629c1897e09f215eddd93c6c"
  _type = "bosch_locator_bridge/ClientLocalizationVisualization"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Copyright (c) 2021 - for information on the respective copyright owner
# see the NOTICE file and/or the repository https://github.com/boschglobal/locator_ros_bridge.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# The time at which the Localization Client received the laser scan used to generate this Datagram
time timestamp

# currently unused; this field is reserved to match a uniqueId provided via the ClientSensorLaser interface
uint64 unique_id

# The localization status
int32 loc_state

# Distance traversed by the sensor since the last successful loop closure
float64 distanceToLastLC

# The relative delay within the system when processing laser scans.
# 0: no delay; 1.0 : delay causes loop closures to be omitted when building the temporary map
float64 delay

# Constants
int32 LOC_STATUS_INFO_LOCALIZATION_NOT_RUNNING = -3
int32 LOC_STATUS_NOT_LOCALIZED_STARTUP = -2
int32 LOC_STATUS_NOT_LOCALIZED = -1
int32 LOC_STATUS_LOCALIZED_ODO_ONLY = 1
int32 LOC_STATUS_LOCALIZED = 2
int32 LOC_STATUS_LOCALIZED_INTERNALUSE1 = 3
int32 LOC_STATUS_LOCALIZED_INTERNALUSE2 = 4
"""
  # Pseudo-constants
  LOC_STATUS_INFO_LOCALIZATION_NOT_RUNNING = -3
  LOC_STATUS_NOT_LOCALIZED_STARTUP = -2
  LOC_STATUS_NOT_LOCALIZED = -1
  LOC_STATUS_LOCALIZED_ODO_ONLY = 1
  LOC_STATUS_LOCALIZED = 2
  LOC_STATUS_LOCALIZED_INTERNALUSE1 = 3
  LOC_STATUS_LOCALIZED_INTERNALUSE2 = 4

  __slots__ = ['timestamp','unique_id','loc_state','distanceToLastLC','delay']
  _slot_types = ['time','uint64','int32','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,unique_id,loc_state,distanceToLastLC,delay

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ClientLocalizationVisualization, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.unique_id is None:
        self.unique_id = 0
      if self.loc_state is None:
        self.loc_state = 0
      if self.distanceToLastLC is None:
        self.distanceToLastLC = 0.
      if self.delay is None:
        self.delay = 0.
    else:
      self.timestamp = genpy.Time()
      self.unique_id = 0
      self.loc_state = 0
      self.distanceToLastLC = 0.
      self.delay = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2IQi2d().pack(_x.timestamp.secs, _x.timestamp.nsecs, _x.unique_id, _x.loc_state, _x.distanceToLastLC, _x.delay))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 36
      (_x.timestamp.secs, _x.timestamp.nsecs, _x.unique_id, _x.loc_state, _x.distanceToLastLC, _x.delay,) = _get_struct_2IQi2d().unpack(str[start:end])
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2IQi2d().pack(_x.timestamp.secs, _x.timestamp.nsecs, _x.unique_id, _x.loc_state, _x.distanceToLastLC, _x.delay))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 36
      (_x.timestamp.secs, _x.timestamp.nsecs, _x.unique_id, _x.loc_state, _x.distanceToLastLC, _x.delay,) = _get_struct_2IQi2d().unpack(str[start:end])
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2IQi2d = None
def _get_struct_2IQi2d():
    global _struct_2IQi2d
    if _struct_2IQi2d is None:
        _struct_2IQi2d = struct.Struct("<2IQi2d")
    return _struct_2IQi2d
