// Auto-generated. Do not edit!

// (in-package bosch_locator_bridge.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class ClientLocalizationPose {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.age = null;
      this.timestamp = null;
      this.unique_id = null;
      this.state = null;
      this.epoch = null;
    }
    else {
      if (initObj.hasOwnProperty('age')) {
        this.age = initObj.age
      }
      else {
        this.age = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('unique_id')) {
        this.unique_id = initObj.unique_id
      }
      else {
        this.unique_id = 0;
      }
      if (initObj.hasOwnProperty('state')) {
        this.state = initObj.state
      }
      else {
        this.state = 0;
      }
      if (initObj.hasOwnProperty('epoch')) {
        this.epoch = initObj.epoch
      }
      else {
        this.epoch = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ClientLocalizationPose
    // Serialize message field [age]
    bufferOffset = _serializer.duration(obj.age, buffer, bufferOffset);
    // Serialize message field [timestamp]
    bufferOffset = _serializer.time(obj.timestamp, buffer, bufferOffset);
    // Serialize message field [unique_id]
    bufferOffset = _serializer.uint64(obj.unique_id, buffer, bufferOffset);
    // Serialize message field [state]
    bufferOffset = _serializer.int32(obj.state, buffer, bufferOffset);
    // Serialize message field [epoch]
    bufferOffset = _serializer.uint64(obj.epoch, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ClientLocalizationPose
    let len;
    let data = new ClientLocalizationPose(null);
    // Deserialize message field [age]
    data.age = _deserializer.duration(buffer, bufferOffset);
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [unique_id]
    data.unique_id = _deserializer.uint64(buffer, bufferOffset);
    // Deserialize message field [state]
    data.state = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [epoch]
    data.epoch = _deserializer.uint64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 36;
  }

  static datatype() {
    // Returns string type for a message object
    return 'bosch_locator_bridge/ClientLocalizationPose';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'ac6078300928d5422e0a422d1c3aef70';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Copyright (c) 2021 - for information on the respective copyright owner
    # see the NOTICE file and/or the repository https://github.com/boschglobal/locator_ros_bridge.
    #
    # Licensed under the Apache License, Version 2.0 (the "License");
    # you may not use this file except in compliance with the License.
    # You may obtain a copy of the License at
    #
    #     http://www.apache.org/licenses/LICENSE-2.0
    #
    # Unless required by applicable law or agreed to in writing, software
    # distributed under the License is distributed on an "AS IS" BASIS,
    # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    # See the License for the specific language governing permissions and
    # limitations under the License.
    
    # The time passed between receiving the most recent laser scan and the generation of this Datagram
    duration age
    
    # The time at which the Localization Client received the laser scan used to generate this Datagram
    time timestamp
    
    # currently unused; this field is reserved to match a uniqueId provided via the ClientSensorLaser interface
    uint64 unique_id
    
    # The localization status
    int32 state
    
    # Only Datagrams with the same epoch can be treated as locally precise
    # and coherent. If the self-localization was temporarily disrupted, the system will
    # indicate this by incrementing the epoch
    uint64 epoch
    
    # Constants
    int32 LOC_STATUS_INFO_LOCALIZATION_NOT_RUNNING = -3
    int32 LOC_STATUS_NOT_LOCALIZED_STARTUP = -2
    int32 LOC_STATUS_NOT_LOCALIZED = -1
    int32 LOC_STATUS_LOCALIZED_ODO_ONLY = 1
    int32 LOC_STATUS_LOCALIZED = 2
    int32 LOC_STATUS_LOCALIZED_INTERNALUSE1 = 3
    int32 LOC_STATUS_LOCALIZED_INTERNALUSE2 = 4
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ClientLocalizationPose(null);
    if (msg.age !== undefined) {
      resolved.age = msg.age;
    }
    else {
      resolved.age = {secs: 0, nsecs: 0}
    }

    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = {secs: 0, nsecs: 0}
    }

    if (msg.unique_id !== undefined) {
      resolved.unique_id = msg.unique_id;
    }
    else {
      resolved.unique_id = 0
    }

    if (msg.state !== undefined) {
      resolved.state = msg.state;
    }
    else {
      resolved.state = 0
    }

    if (msg.epoch !== undefined) {
      resolved.epoch = msg.epoch;
    }
    else {
      resolved.epoch = 0
    }

    return resolved;
    }
};

// Constants for message
ClientLocalizationPose.Constants = {
  LOC_STATUS_INFO_LOCALIZATION_NOT_RUNNING: -3,
  LOC_STATUS_NOT_LOCALIZED_STARTUP: -2,
  LOC_STATUS_NOT_LOCALIZED: -1,
  LOC_STATUS_LOCALIZED_ODO_ONLY: 1,
  LOC_STATUS_LOCALIZED: 2,
  LOC_STATUS_LOCALIZED_INTERNALUSE1: 3,
  LOC_STATUS_LOCALIZED_INTERNALUSE2: 4,
}

module.exports = ClientLocalizationPose;
