// Auto-generated. Do not edit!

// (in-package bosch_locator_bridge.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class ClientMapVisualization {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.timestamp = null;
      this.visualization_id = null;
      this.status = null;
      this.distanceToLastLC = null;
      this.delay = null;
      this.progress = null;
      this.path_types = null;
    }
    else {
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('visualization_id')) {
        this.visualization_id = initObj.visualization_id
      }
      else {
        this.visualization_id = 0;
      }
      if (initObj.hasOwnProperty('status')) {
        this.status = initObj.status
      }
      else {
        this.status = 0;
      }
      if (initObj.hasOwnProperty('distanceToLastLC')) {
        this.distanceToLastLC = initObj.distanceToLastLC
      }
      else {
        this.distanceToLastLC = 0.0;
      }
      if (initObj.hasOwnProperty('delay')) {
        this.delay = initObj.delay
      }
      else {
        this.delay = 0.0;
      }
      if (initObj.hasOwnProperty('progress')) {
        this.progress = initObj.progress
      }
      else {
        this.progress = 0.0;
      }
      if (initObj.hasOwnProperty('path_types')) {
        this.path_types = initObj.path_types
      }
      else {
        this.path_types = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ClientMapVisualization
    // Serialize message field [timestamp]
    bufferOffset = _serializer.time(obj.timestamp, buffer, bufferOffset);
    // Serialize message field [visualization_id]
    bufferOffset = _serializer.uint64(obj.visualization_id, buffer, bufferOffset);
    // Serialize message field [status]
    bufferOffset = _serializer.int32(obj.status, buffer, bufferOffset);
    // Serialize message field [distanceToLastLC]
    bufferOffset = _serializer.float64(obj.distanceToLastLC, buffer, bufferOffset);
    // Serialize message field [delay]
    bufferOffset = _serializer.float64(obj.delay, buffer, bufferOffset);
    // Serialize message field [progress]
    bufferOffset = _serializer.float64(obj.progress, buffer, bufferOffset);
    // Serialize message field [path_types]
    bufferOffset = _arraySerializer.int32(obj.path_types, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ClientMapVisualization
    let len;
    let data = new ClientMapVisualization(null);
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [visualization_id]
    data.visualization_id = _deserializer.uint64(buffer, bufferOffset);
    // Deserialize message field [status]
    data.status = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [distanceToLastLC]
    data.distanceToLastLC = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [delay]
    data.delay = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [progress]
    data.progress = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [path_types]
    data.path_types = _arrayDeserializer.int32(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += 4 * object.path_types.length;
    return length + 48;
  }

  static datatype() {
    // Returns string type for a message object
    return 'bosch_locator_bridge/ClientMapVisualization';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '8dd03d1d65c83775293ab6133751e6f6';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Copyright (c) 2021 - for information on the respective copyright owner
    # see the NOTICE file and/or the repository https://github.com/boschglobal/locator_ros_bridge.
    #
    # Licensed under the Apache License, Version 2.0 (the "License");
    # you may not use this file except in compliance with the License.
    # You may obtain a copy of the License at
    #
    #     http://www.apache.org/licenses/LICENSE-2.0
    #
    # Unless required by applicable law or agreed to in writing, software
    # distributed under the License is distributed on an "AS IS" BASIS,
    # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    # See the License for the specific language governing permissions and
    # limitations under the License.
    
    # The time at which the Localization Client received the laser scan used to generate this Datagram
    time timestamp
    
    # A unique id for matching datagrams that were emitted at the same time but by different visualization interfaces
    uint64 visualization_id
    
    # The ClientRecordingRecordingStatus
    int32 status
    
    # Distance traversed by the sensor since the last successful loop closure
    float64 distanceToLastLC
    
    # The relative delay within the system when processing laser scans.
    # 0: no delay; 1.0 : delay causes loop closures to be omitted when building the temporary map
    float64 delay
    
    # Currently unused
    float64 progress
    
    # Please note that pose, scan, and path_poses is published directly via the standard message types (custom nested messages would hinder using ros tools, such as rviz)
    
    #  Array of order state_1, state_2, using the ClientRecordingPathTypeEnum
    int32[] path_types
    
    
    # Constants
    int32 CLIENT_RECORDING_RECORDING_STATUS_STARTUP = -2
    int32 CLIENT_RECORDING_RECORDING_STATUS_DELAYED = 1
    int32 CLIENT_RECORDING_RECORDING_STATUS_OK = 2
    
    int32 CLIENT_RECORDING_PATH_TYPE_ENUM_NORMAL = 0
    int32 CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLE_LOOP_CLOSURE = 1
    int32 CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLY_VISIBLE_LOOP_CLOSURE = 2
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ClientMapVisualization(null);
    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = {secs: 0, nsecs: 0}
    }

    if (msg.visualization_id !== undefined) {
      resolved.visualization_id = msg.visualization_id;
    }
    else {
      resolved.visualization_id = 0
    }

    if (msg.status !== undefined) {
      resolved.status = msg.status;
    }
    else {
      resolved.status = 0
    }

    if (msg.distanceToLastLC !== undefined) {
      resolved.distanceToLastLC = msg.distanceToLastLC;
    }
    else {
      resolved.distanceToLastLC = 0.0
    }

    if (msg.delay !== undefined) {
      resolved.delay = msg.delay;
    }
    else {
      resolved.delay = 0.0
    }

    if (msg.progress !== undefined) {
      resolved.progress = msg.progress;
    }
    else {
      resolved.progress = 0.0
    }

    if (msg.path_types !== undefined) {
      resolved.path_types = msg.path_types;
    }
    else {
      resolved.path_types = []
    }

    return resolved;
    }
};

// Constants for message
ClientMapVisualization.Constants = {
  CLIENT_RECORDING_RECORDING_STATUS_STARTUP: -2,
  CLIENT_RECORDING_RECORDING_STATUS_DELAYED: 1,
  CLIENT_RECORDING_RECORDING_STATUS_OK: 2,
  CLIENT_RECORDING_PATH_TYPE_ENUM_NORMAL: 0,
  CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLE_LOOP_CLOSURE: 1,
  CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLY_VISIBLE_LOOP_CLOSURE: 2,
}

module.exports = ClientMapVisualization;
